
-- **********************************************************************

--     Practica de Ficheros y Bases de Datos
--     Gestion de Autobuses
--     Grupo practica: C2-6(R)

--               26-ABRIL-96

--     Paquete para listar el contenido del fichero indice
--  utilizado dentro del procedimiento "LISTAR"

-- ************************************************************************


  With Direct_IO, Text_io, TiposDef;

PACKAGE body LisBTree Is

   Type A_Tuple Is Record

                   key : TiposDef.TClave;

                   address : Positive;

                   subtree : Natural;

                End Record;

   Type Tuple_Array Is Array ( Integer Range <> ) Of A_Tuple;

   Type Node_Type Is Record

                   number_of_tuples : Natural;

                   first_subtree   : Natural;

                   tuple           : Tuple_Array (1 .. degree - 1 );

                End Record;

   Package B_Tree_IO Is New Direct_IO ( Node_Type );

   b_tree_file : B_Tree_IO.File_Type;



 --
 -- Listar contenido del arbol en en fichero de texto
 --
 
   Procedure List_B_Tree ( nombre_indice, nombre_listado : String ) Is

       UnNodo : Node_Type;
       NumReg : Natural := 1;
       Fichero_Listado : Text_io.File_Type;
       package ES_Naturales is new Text_io.Integer_io(Natural);
  
   
     Begin

       B_Tree_IO.Open(b_tree_file, B_Tree_IO.IN_FILE, nombre_indice);
       Text_io.Create(Fichero_Listado, Text_io.OUT_FILE, nombre_listado);
       
       if not (B_Tree_IO.End_of_File (b_tree_file)) then
       
          B_Tree_IO.Read ( b_tree_file, UnNodo );
          Text_io.Put( Fichero_Listado, "Raiz: ");
          ES_Naturales.Put (Fichero_Listado, UnNodo.Number_of_tuples, 3);
          Text_io.New_Line (Fichero_Listado );
          
          Text_io.Put(Fichero_Listado,"Reg");
          for i in 1..degree loop
             Text_io.Put (Fichero_Listado,"     Clave PR");
          end loop;
          Text_io.New_Line(Fichero_Listado,2);   
          
          while not (B_Tree_IO.End_of_File (b_tree_file)) loop
     
             B_Tree_IO.Read ( b_tree_file, UnNodo );
             NumReg := NumReg + 1;
             ES_Naturales.Put (Fichero_Listado, NumReg, 3);
             Text_io.Put ( Fichero_Listado, ":");
             ES_Naturales.Put (Fichero_Listado, UnNodo.first_subtree, 3);
             Text_io.Put ( Fichero_Listado, "|");
             
             for i in 1..UnNodo.Number_of_Tuples loop
        
                ES_Naturales.Put (Fichero_Listado, UnNodo.tuple(i).key, 3);
                Text_io.Put (Fichero_Listado, " -"); 
                ES_Naturales.Put (Fichero_Listado,UnNodo.tuple(i).address, 3);
                Text_io.Put (Fichero_Listado, "|");
                ES_Naturales.Put (Fichero_Listado,UnNodo.tuple(i).subtree, 3);
                Text_io.Put (Fichero_Listado, "|");
        
             end loop;
     
             Text_io.New_Line ( Fichero_Listado );
   
          end loop;
    
       end if;
  
       B_Tree_io.Close ( b_tree_file );
       Text_io.Close ( Fichero_Listado );
  
     end List_B_Tree;

end LisBTree;